## ipmctl 03.00.00.0423

=== CMakeLists.txt ===
# Copyright (c) 2018, Intel Corporation.
# SPDX-License-Identifier: BSD-3-Clause

cmake_minimum_required(VERSION 2.8.12)

message("cmake version: " ${CMAKE_VERSION})

project(ipmctl)

# Enable tests that may be contained in the below subdirectories
enable_testing()

set(CMAKE_VERBOSE_MAKEFILE on)

get_filename_component(ROOT ./ ABSOLUTE)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/CMake/Find")

set(LIBIPMCTL_VERSION_MAJOR 5)
set(LIBIPMCTL_VERSION_MINOR 2)
set(LIBIPMCTL_VERSION_PATCH 0)
set(LIBIPMCTL_VERSION_STRING ${LIBIPMCTL_VERSION_MAJOR}.${LIBIPMCTL_VERSION_MINOR}.${LIBIPMCTL_VERSION_PATCH})

set(IPMCTL_VERSION_MAJOR 03)
set(IPMCTL_VERSION_MINOR 01)
set(IPMCTL_VERSION_PATCH 00)

set(IPMCTL_SPEC_VERSION_MAJOR 3)
set(IPMCTL_SPEC_VERSION_MINOR 03)
set(IPMCTL_DRAFT "")
set(IPMCTL_SPEC_VERSION_STRING ${IPMCTL_SPEC_VERSION_MAJOR}.${IPMCTL_SPEC_VERSION_MINOR}${IPMCTL_DRAFT})

if(BUILDNUM)
  set(IPMCTL_VERSION_STRING ${BUILDNUM})
else()
  find_package(Git)
  if(GIT_FOUND)
    execute_process(COMMAND ${GIT_EXECUTABLE} describe --tag --dirty
      OUTPUT_VARIABLE IPMCTL_VERSION_STRING
      RESULT_VARIABLE GIT_RETURN_CODE
      )
    # strip leading string in git tag
    string(REGEX MATCH "([0-9]+\\.[0-9]+\\.[0-9]+\\.[0-9]+)" IPMCTL_VERSION_STRING "${IPMCTL_VERSION_STRING}")
    # strip ending newline
    string(REGEX REPLACE "\n" "" IPMCTL_VERSION_STRING "${IPMCTL_VERSION_STRING}")
  endif()

  if(NOT GIT_FOUND OR ${GIT_RETURN_CODE})
    set(IPMCTL_VERSION_STRING ${IPMCTL_VERSION_MAJOR}.${IPMCTL_VERSION_MINOR}.${IPMCTL_VERSION_PATCH}.0423)
  endif()
endif()

message(VERSION: ${IPMCTL_VERSION_STRING})

if(RELEASE OR CMAKE_BUILD_TYPE STREQUAL "Release")
  set(BUILD_TYPE release)
  set(CMAKE_BUILD_TYPE Release)
  SET(CMAKE_SKIP_BUILD_RPATH TRUE)
else()
  set(BUILD_TYPE debug)
  set(CMAKE_BUILD_TYPE Debug)
  add_definitions(
    -DDEBUG_BUILD
  )
endif()

message(CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE})

if(BUILD_STATIC)
  set(LIB_TYPE STATIC)
else()
  set(LIB_TYPE SHARED)
endif()

find_package(PythonInterp REQUIRED)

if(ESX_BUILD)
  set(OS_TYPE esx)
  set(FILE_PREFIX esx)
  set(CMAKE_SKIP_BUILD_RPATH FALSE)
  set(CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)
  set(CMAKE_INSTALL_RPATH "/opt/intel/bin")

else()
  ## Common packages between Windows and Linux

  # Optional packages for documentation
  ## Unfortunately it sounds like we can't do conditional inclusion
  ## based on the target selected.
  find_package(a2x)
  find_package(asciidoctor)
  find_package(asciidoc)

  if(UNIX)
    set(LNX_BUILD 1)
    set(OS_TYPE linux)
    set(FILE_PREFIX lnx)
    find_package(PkgConfig REQUIRED)
    pkg_check_modules(NDCTL REQUIRED libndctl>=58.2)
    pkg_check_modules(SYSTEMD systemd)
    find_package(Threads REQUIRED)
  elseif(MSVC)
    set(WIN_BUILD 1)
    set(OS_TYPE win)
    set(FILE_PREFIX win)
  endif()
endif()

message(BUILD_TYPE: ${CMAKE_BUILD_TYPE})
message(OS_TYPE: ${OS_TYPE})
message(LIB_TYPE: ${LIB_TYPE})
message(COMPILER: ${CMAKE_C_COMPILER})
message(SYSROOT: ${MY_CMAKE_SYSROOT})
message(TOOLCHAIN: ${CMAKE_TOOLCHAIN_FILE})

set(OUTPUT_DIR ${ROOT}/output/${BUILD_TYPE})
file(MAKE_DIRECTORY ${OUTPUT_DIR})
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${ROOT}/output/${BUILD_TYPE})
set(CMAKE_BINARY_DIR ${OUTPUT_DIR})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

if(INTERNAL_MFG)
        include(CMake/mfg.cmake)
endif()

#----------------------------------------------------------------------------------------------------
# Project wide defines and flags
#----------------------------------------------------------------------------------------------------
add_definitions(
  -DOS_BUILD
  -DPCD_CACHE_ENABLED
  -D__VERSION_NUMBER__=${IPMCTL_VERSION_STRING}
  -DPLAYBACK_RECORD_SUPPORTED
  )

# Promote warnings to errors only for release builds
if(MSVC)
  set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} /O2 /WX")
  set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /O2 /WX")
  set(CMAKE_C_FLAGS_DEBUG_ "${CMAKE_C_FLAGS_DEBUG} /Od")
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /Od")
else()
  set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -O2 -fno-strict-aliasing -D_FORTIFY_SOURCE=2")
  set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O2 -fno-strict-aliasing -D_FORTIFY_SOURCE=2")
  if(LNX_BUILD)
    #A few warnings yet to resolve under esx
    set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -Werror")
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -Werror")
  endif()
  set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -O0 -ggdb")
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -O0 -ggdb")
endif()

if(UNIX)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DNO_MSABI_VA_FUNCS -std=c99 -Wformat -Wformat-security -D_XOPEN_SOURCE=500 -Wall -Wfatal-errors -MMD -fPIC -fno-strict-aliasing")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wformat -Wformat-security -D_XOPEN_SOURCE=500 -Drestrict=__restrict__ -Wall -Wfatal-errors -MMD -fPIC -fno-strict-aliasing")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -z noexecstack -z relro -z now -pie")
elseif(MSVC)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /GS /DynamicBase /sdl")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /GS /DynamicBase /sdl")
  set(CMAKE_SHARED_LINKER_FLAGS "/NXCompat")
endif()

if(LNX_BUILD)
  if("${CMAKE_INSTALL_DATAROOTDIR}" STREQUAL "/usr/share")
    # Workaround for the RPM build cause the %{_datarootdir} is already prefixed
    set(INI_INSTALL_FILEPATH "${CMAKE_INSTALL_DATAROOTDIR}")
  else()
    if("${CMAKE_INSTALL_PREFIX}" STREQUAL "/")
      # In case the CMAKE_INSTALL_PREFIX equals "/" for <dir> other than the SYSCONFDIR and LOCALSTATEDIR,
      # the value of CMAKE_INSTALL_<dir> is prefixed with usr/ if it is not user-specified as an absolute path.
      set(CMAKE_INSTALL_PREFIX "/usr")
      message("CMAKE_INSTALL_PREFIX value changed to: ${CMAKE_INSTALL_PREFIX}")
    endif()
    if(NOT DEFINED CMAKE_INSTALL_DATAROOTDIR)
      set(CMAKE_INSTALL_DATAROOTDIR "share")
      message("CMAKE_INSTALL_DATAROOTDIR not defined. Creating a new definition with value: ${CMAKE_INSTALL_DATAROOTDIR}")
    endif()
    set(INI_INSTALL_FILEPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATAROOTDIR}")
  endif()
  message("INI_INSTALL_FILEPATH definition create with value: ${INI_INSTALL_FILEPATH}")
  add_definitions(
    -D_GNU_SOURCE
    -D__LINUX__
    -DHAVE_C99
    -DINI_INSTALL_FILEPATH="${INI_INSTALL_FILEPATH}/ipmctl/"
    )
  if(CMAKE_C_COMPILER_ID STREQUAL "GNU" AND CMAKE_C_COMPILER_VERSION VERSION_GREATER 4.9)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector-strong")
  endif()
  if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 4.9)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-strong")
  endif()
endif()

if(MSVC)
  if(VCREDIST_STATIC)
    # Force vcredist to be linked static
    # Keep this after all other compiler flag setup
    set(CompilerFlags
        CMAKE_CXX_FLAGS
        CMAKE_CXX_FLAGS_DEBUG
        CMAKE_CXX_FLAGS_RELEASE
        CMAKE_CXX_FLAGS_RELWITHDEBINFO
        CMAKE_C_FLAGS
        CMAKE_C_FLAGS_DEBUG
        CMAKE_C_FLAGS_RELEASE
        CMAKE_C_FLAGS_RELWITHDEBINFO
        )
    foreach(CompilerFlag ${CompilerFlags})
      string(REPLACE "/MD" "/MT" ${CompilerFlag} "${${CompilerFlag}}")
    endforeach()
    message("VCREDIST: STATIC")
  else()
    message("VCREDIST: SHARED")
  endif()
endif()

#----------------------------------------------------------------------------------------------------
# OS driver interface library
#----------------------------------------------------------------------------------------------------
if(MSVC)

  # setup resource file for file details
  string(REGEX REPLACE "[.]" "," IPMCTL_VERSION_COMMA_STRING "${IPMCTL_VERSION_STRING}")

  # exe
  set (NAME_RC ${CMAKE_PROJECT_NAME})
  set (NAME_RC_EXT "${NAME_RC}.exe")
  set (VFT_TYPE "VFT_APP")
  configure_file(src/os/win/ipmctl.rc.in src/os/win/ipmctl.rc @ONLY)

  # lib
  set (NAME_RC "lib${CMAKE_PROJECT_NAME}")
  set (NAME_RC_EXT "${NAME_RC}.dll")
  set (VFT_TYPE "VFT_DLL")
  configure_file(src/os/win/ipmctl.rc.in src/os/win/libipmctl.rc @ONLY)

  FILE(GLOB OS_INTERFACE_SOURCE_FILES
    src/os/os_str.c
    src/os/os_common.c
    src/os/win/win_scm2_ioctl.c
    src/os/win/win_scm2_passthrough.c
    src/os/win/win_scm2_ioctl_passthrough.c
    src/os/win/win_common.c
    src/os/win/win_api.c
    src/os/win/win_scm2_adapter.c
    src/os/win/win_system.c
    )
elseif(UNIX)
  FILE(GLOB OS_INTERFACE_SOURCE_FILES
    src/os/os_str.c
    src/os/os_common.c
    src/os/${OS_TYPE}/${FILE_PREFIX}_adapter_passthrough.c
    src/os/${OS_TYPE}/${FILE_PREFIX}_acpi.c
    src/os/${OS_TYPE}/${FILE_PREFIX}_common.c
    src/os/${OS_TYPE}/${FILE_PREFIX}_api.c
    src/os/${OS_TYPE}/${FILE_PREFIX}_adapter.c
    src/os/${OS_TYPE}/${FILE_PREFIX}_system.c
    )
endif()

add_library(ipmctl_os_interface STATIC ${OS_INTERFACE_SOURCE_FILES})

target_link_libraries(ipmctl_os_interface
  ${CMAKE_THREAD_LIBS_INIT}
  )

target_include_directories(ipmctl_os_interface PUBLIC
  src/os
  src/os/${OS_TYPE}
  DcpmPkg/common
  DcpmPkg/cli
  src/os/nvm_api
  src/os/s_string
  MdePkg/Include
  MdePkg/Include/Uefi
  src/os/efi_shim
  )

if (MSVC)
  string(REGEX REPLACE "([0-9]+)\\.[0-9]+\\.[0-9]+\\.[0-9]+" "\\1" sdk_version_major $ENV{WindowsSDKVersion})
  string(REGEX REPLACE "[0-9]+\\.([0-9]+)\\.[0-9]+\\.[0-9]+" "\\1" sdk_version_major2 $ENV{WindowsSDKVersion})
  string(REGEX REPLACE "[0-9]+\\.[0-9]+\\.([0-9]+)\\.[0-9]+" "\\1" sdk_version_minor $ENV{WindowsSDKVersion})
  if (${sdk_version_major} GREATER 9 AND ${sdk_version_minor} GREATER 17650)
    MESSAGE("Using Windows SDK 17650+")
  else()
    MESSAGE(FATAL_ERROR "Requires Windows SDK version 17650 or newer.")
  endif()
endif()

#----------------------------------------------------------------------------------------------------
# libipmctl
#----------------------------------------------------------------------------------------------------
file(GLOB LIBIPMCTL_SOURCE_FILES
  src/os/efi_shim/AutoGen.c
  src/os/efi_shim/AutoGenIo.c
  src/os/efi_shim/os_efi_api.c
  src/os/efi_shim/os_efi_api_io.c
  src/os/efi_shim/os_efi_preferences.c
  src/os/efi_shim/os_efi_shell_parameters_protocol.c
  src/os/efi_shim/os_efi_simple_file_protocol.c
  src/os/efi_shim/os_efi_bs_protocol.c
  src/os/ini/ini.c
  src/os/eventlog/event.c
  src/os/nvm_api/nvm_management.c
  src/os/nvm_api/nvm_output_parsing.c
  src/os/s_string/s_str.c
  DcpmPkg/cli/NvmDimmCli.c
  DcpmPkg/cli/CommandParser.c
  DcpmPkg/cli/Common.c
  DcpmPkg/cli/ShowAcpiCommand.c
  DcpmPkg/cli/ShowSensorCommand.c
  DcpmPkg/cli/ShowDimmsCommand.c
  DcpmPkg/cli/ShowSocketsCommand.c
  DcpmPkg/cli/ShowMemoryResourcesCommand.c
  DcpmPkg/cli/ShowSystemCapabilitiesCommand.c
  DcpmPkg/cli/ShowFirmwareCommand.c
  DcpmPkg/cli/ShowPcdCommand.c
  DcpmPkg/cli/DeletePcdCommand.c
  DcpmPkg/cli/ShowRegionsCommand.c
  DcpmPkg/cli/CreateGoalCommand.c
  DcpmPkg/cli/ShowGoalCommand.c
  DcpmPkg/cli/DeleteGoalCommand.c
  DcpmPkg/cli/ShowErrorCommand.c
  DcpmPkg/cli/ShowCelCommand.c
  DcpmPkg/cli/DumpDebugCommand.c
  DcpmPkg/cli/StartDiagnosticCommand.c
  DcpmPkg/cli/ShowPreferencesCommand.c
  DcpmPkg/cli/ShowTopologyCommand.c
  DcpmPkg/cli/SetPreferencesCommand.c
  DcpmPkg/cli/SetSensorCommand.c
  DcpmPkg/cli/LoadGoalCommand.c
  DcpmPkg/cli/DumpGoalCommand.c
  DcpmPkg/cli/SetDimmCommand.c
  DcpmPkg/cli/LoadCommand.c
  DcpmPkg/cli/DeleteDimmCommand.c
  src/os/cli_cmds/DumpSupportCommand.c
  DcpmPkg/cli/ShowRegisterCommand.c
  DcpmPkg/cli/StartFormatCommand.c
  DcpmPkg/cli/ShowPerformanceCommand.c
  DcpmPkg/cli/ShowHostServerCommand.c
  DcpmPkg/cli/ShowCmdAccessPolicyCommand.c
  DcpmPkg/cli/StartSessionCommand.c
  DcpmPkg/cli/StopSessionCommand.c
  DcpmPkg/cli/LoadSessionCommand.c
  DcpmPkg/cli/ShowSessionCommand.c
  DcpmPkg/cli/DumpSessionCommand.c
  DcpmPkg/common/FwUtility.c
