=== debian/changelog ===
ipmctl (03.00.00.0423-1~bpo20.04.1) focal-backports; urgency=medium

  * Backport to Focal (LP: #1968076)
  * Lower dh compat level to 12.

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 06 Apr 2022 20:00:27 +0200

ipmctl (03.00.00.0423-1) unstable; urgency=medium

  * New upstream release.
  * Upload to unstable.

 -- Adam Borowski <kilobyte@angband.pl>  Fri, 07 Jan 2022 02:25:01 +0100

ipmctl (03.00.00.0421-2) experimental; urgency=medium

  * Move configuration and log pieces to a new binary package,
    libipmctl-common, to ease future upgrades.

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 29 Dec 2021 16:41:03 +0100

ipmctl (03.00.00.0421-1) experimental; urgency=medium

  * New upstream release.
  * Update symbols.

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 29 Dec 2021 16:27:33 +0100

ipmctl (03.00.00.0407-1) experimental; urgency=medium

  * Switch to the 3.0 branch.
  * No need to repack anymore
  * ... as edk2 bits are not in the upstream tarball, but need to be shipped
    separately.
  * Soname bump: libipmctl4→5.
  * Drop handling of upgrades from libipmctl3 (never part of a stable
    release).

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 10 Nov 2021 18:08:37 +0100

ipmctl (02.00.00.3885+ds-1) unstable; urgency=medium

  * New upstream release.
  * Add a new symbol.
  * dh 13.

 -- Adam Borowski <kilobyte@angband.pl>  Tue, 17 Aug 2021 01:56:40 +0200
