=== debian/control ===
Source: ipmctl
Section: admin
Priority: optional
Maintainer: Adam Borowski <kilobyte@angband.pl>
Build-Depends: debhelper-compat (= 12),
               cmake,
               libndctl-dev,
               pkg-config,
               python3,
               asciidoctor
Standards-Version: 4.6.0
Rules-Requires-Root: no
Homepage: https://github.com/intel/ipmctl
Vcs-Browser: https://github.com/kilobyte/ipmctl/tree/debian
Vcs-Git: https://github.com/kilobyte/ipmctl -b debian

Package: ipmctl
Architecture: amd64
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: utility for configuring and managing Intel Optane DC persistent memory modules
 This package provides a CLI with the following functionality:
  * Discover PMMs on the platform.
  * Provision the platform memory configuration.
  * View and update the firmware on PMMs.
  * Configure data-at-rest security on PMMs.
  * Monitor PMM health.
  * Track performance of PMMs.
  * Debug and troubleshoot PMMs.

Package: libipmctl-common
Section: libs
Architecture: all
Multi-Arch: foreign
Depends: ${shlibs:Depends},
         ${misc:Depends},
Breaks: libipmctl3, libipmctl4, libipmctl5 (<< 03.00.00.0421-2~)
Replaces: libipmctl3, libipmctl4, libipmctl5 (<< 03.00.00.0421-2~)
Description: library for managing Intel Optane DC persistent memory modules
 This package provides an API for the following functionality:
  * Discover PMMs on the platform.
  * Provision the platform memory configuration.
  * View and update the firmware on PMMs.
  * Configure data-at-rest security on PMMs.
  * Monitor PMM health.
  * Track performance of PMMs.
  * Debug and troubleshoot PMMs
 .
 This package contains common conf files.

Package: libipmctl5
Section: libs
Architecture: amd64
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libipmctl-common,
Description: library for managing Intel Optane DC persistent memory modules
 This package provides an API for the following functionality:
  * Discover PMMs on the platform.
  * Provision the platform memory configuration.
  * View and update the firmware on PMMs.
  * Configure data-at-rest security on PMMs.
  * Monitor PMM health.
  * Track performance of PMMs.
  * Debug and troubleshoot PMMs
 .
 This package contains the runtime library.

Package: libipmctl-dev
Section: libdevel
Architecture: amd64
Multi-Arch: same
Depends: libipmctl5 (=${binary:Version}),
         ${misc:Depends}
Description: library for managing Intel Optane DC persistent memory modules - devel
 This package provides an API for the following functionality:
  * Discover PMMs on the platform.
  * Provision the platform memory configuration.
  * View and update the firmware on PMMs.
  * Configure data-at-rest security on PMMs.
  * Monitor PMM health.
  * Track performance of PMMs.
  * Debug and troubleshoot PMMs.
 .
 This package contains C development headers.
