## ipmctl 03.00.00.0438

=== debian/changelog ===
ipmctl (03.00.00.0438-1) unstable; urgency=medium

  * New upstream release.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 16 May 2022 09:38:46 +0200

ipmctl (03.00.00.0429-1) unstable; urgency=medium

  * New upstream bugfix release.
    + Includes not leaking private symbols.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 07 Mar 2022 10:37:46 +0100
