=== debian/changelog ===
ipmctl (03.00.00.0439-1) unstable; urgency=medium

  * Fix FTBFS with kernel 5.18 headers (closes: #1013547)

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 29 Jun 2022 17:51:39 +0200
