## ipmctl 03.00.00.0468

=== CMakeLists.txt ===
--- 
+++ 
@@ -46,7 +46,7 @@
   endif()
 
   if(NOT GIT_FOUND OR ${GIT_RETURN_CODE})
-    set(IPMCTL_VERSION_STRING ${IPMCTL_VERSION_MAJOR}.${IPMCTL_VERSION_MINOR}.${IPMCTL_VERSION_PATCH}.0439)
+    set(IPMCTL_VERSION_STRING ${IPMCTL_VERSION_MAJOR}.${IPMCTL_VERSION_MINOR}.${IPMCTL_VERSION_PATCH}.0468)
   endif()
 endif()
