=== debian/changelog ===
ipmctl (03.00.00.0468-1) unstable; urgency=medium

  * New upstream release.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 26 Sep 2022 23:23:50 +0200

ipmctl (03.00.00.0462-1) unstable; urgency=medium

  * New upstream release.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 29 Aug 2022 14:17:28 +0200
