=== debian/changelog ===
ipmctl (03.00.00.0485-1) unstable; urgency=medium

  * New upstream release, a large branch switch.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 12 Jun 2023 16:06:38 +0200
