=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

EDK2_DIRS = BaseTools MdeModulePkg MdePkg ShellPkg

%:
	dh $@  

override_dh_auto_configure:
	for x in $(EDK2_DIRS);do ln -sf edk2/$$x $x;done
	dh_auto_configure -- \
	      -DBUILDNUM=`dpkg-parsechangelog -SVersion|cut -d+ -f1`

override_dh_clean:
	dh_clean
	rm -rf output
	rm -f $(EDK2_DIRS)
